#include "pluginManager.h"


pluginManager::pluginManager(){}	
pluginManager::~pluginManager(){}

// ============================= LOAD PLUGINS ============================ //
void pluginManager::load_plugins()
{
	static unsigned int BUF_SIZE = 1024;
    void *dlib;					// Plugin Handel
	FILE *dl;					// File Handle
	char in_buf[BUF_SIZE]; 		// input buffer for lib
    char name[1024]; 


	// == Read Directory == //
 	dl = popen("ls /usr/share/gloobus/plugins/*.so", "r");		//List all plugins (*.so);
   	if(!dl){      
		perror("popen");      
		exit(-1);   	
	}

	// == Load Plugins == //
	//TODO: If there are errors, don't load the plugin that gives error
	printf("LOADING PLUGINS:\n");
	while(fgets(in_buf, BUF_SIZE, dl))
	{
		char *ws = strpbrk(in_buf, " \t\n");	// trim off the whitespace
		if(ws) *ws = '\0';
		sprintf(name, "%s", in_buf);	      	// append ./ to the front of the lib name
		printf("\t %s\n",name);			

		dlib = dlopen(name, RTLD_NOW);			// Load Plugin
		if(dlib == NULL){
			printf("Error loading Plugin: %s\n", dlerror());
			exit(-1);
		}
		
		// == See if versions match == //
		getVersion_t* get_version=(getVersion_t*) dlsym(dlib,"getVersion");
		if(get_version() != MANAGER_VERSION)
		{
			printf("error: the plugin doesn't match the manager version\n");
			exit(-1);
		}
		m_dl_list.insert(m_dl_list.end(), dlib);	// add the handle to our list
	}
	fclose(dl);
}

// ============================= UNLOAD PLUGINS ========================== //
void pluginManager::unload_plugins()
{
	for(m_itr=m_dl_list.begin(); m_itr!=m_dl_list.end(); m_itr++)
	{
		dlclose(*m_itr);
	}
 
}
// ============================= SEARCH FILETYPE ========================= //
string pluginManager::search_plugin_for_file(string filename)
{
	// LIBMAGIC
	magic_t myt = magic_open(MAGIC_CONTINUE|MAGIC_ERROR|MAGIC_MIME);
	magic_load(myt,NULL);
  	string filetype = magic_file(myt,filename.c_str());
  	magic_close(myt);
  	
  	printf("FileType: %s\n",filetype.c_str());
  	
	for(unsigned int i=0; i<pluginVector.size(); i++)
	{
		if(filetype == pluginVector[i].filetype) return pluginVector[i].name;
	}
	return "NULL";
}
