#ifndef _iFolder_
#define _iFolder_

#include <cmath>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_rotozoom.h>

#include "../iGloobus.h"
#include "font.h"

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version!!
#define PLUGIN_NAME	 	"iFolder"	// TODO: Define here the plugin Name

using namespace std;

// ============================ Plugin Class iFolder ==================================== //

class iFolder : public iGloobus 	//Class inherited from iGloobus
{	
	private:
	SDL_Surface *					m_photo;
	Font2							m_font;
	vector<string>					m_files;
	string							m_size;
	string							m_numberOfFiles;
	int								m_textureType;
	bool							m_alphaFolder;
	
	public:

	virtual void load();						// Load the Photo
	virtual void init();						// Initialize the plugin
	virtual void end();							// Destroy the plugin
	virtual void render();						// Render function	
	virtual void update(char key[]){};			// Update function
	virtual void get_size(int *w, int *h);		// To know the size of the GL window (on preview)
		
	void		load_texture();					 // Private (Load Texture)
	void		scale_photo(int wMax, int hMax); // Resize the big photos to use less mem
	void		draw_text();					 // Draw text rutine
	void		load_files_names();				 // Load the files names in the folder
	void 		load_folder_size();				 // Loads the size of the directory
};


// ============================ Class factories======================================== //

extern "C" iGloobus* create() {
	printf("Creating iFolder...\n");
    return new iFolder;
}

extern "C" void destroy(iGloobus* p) {
	printf("Destroying iFolder...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports	
			plugin_filetype itself = { PLUGIN_NAME, "application/x-not-regular-file",1};		// Initial filetype

			factory[itself.name] = create;		    // Register the plugin
			factoryDestroy[itself.name] = destroy;	// Function for destroy this plugin class
			
			pluginVector.push_back(itself);			// Add filetype that plugin reads
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

