#include "iVideo.h"

#define MAX_W 900
#define MAX_H 700

#define MIN_W 300		// MIN SIZE, if the image is smallest than it
#define MIN_H 300		// It goes fucking slow!!


// ============================= LOAD =========================== //
void iVideo::load()
{
	printf("Loading Video: %s\n",m_filename.c_str());
	m_video = new Video;
	//create_video();

}
// ============================= INIT ========================= //
void iVideo::init()
{
	create_video();
/*
	printf("Initializing iPhoto (Scale down and create texture)\n");
	//TODO: Gloobus size depending on screen window size
	if(m_gloobus_type == PREVIEW)	scale_photo(MAX_W,MAX_H);			//PREVIEW: MAX SIZE
	else							scale_photo(300,300);				//GLOOBUS: SMALL SIZE

	load_texture();
*/
}
// ============================= END ========================== //
void iVideo::end()
{

	printf("Ending iPhoto\n");
	glDeleteTextures(1,&m_textureID);
	//SDL_FreeSurface(m_photo);
    av_free(m_video->pFrame);
    avcodec_close(m_video->pCodecCtx);
    av_close_input_file(m_video->pFormatCtx);


}

// ============================= UPDATE ========================== //
void iVideo::update(char key[])
{

	//printf("Loading Frame \n");
   //clock_t render_frame_time = start_timer();
    if(av_read_frame(m_video->pFormatCtx, &m_video->packet) < 0) {
        fprintf(stderr, "Video End\n");
        exit(-1);
		//return(-1);
    }
    int frame_finished = 0;
    if(m_video->packet.stream_index == m_video->videoStream) 
	{

        avcodec_decode_video(m_video->pCodecCtx, m_video->pFrame, 
            &m_video->frameFinished, m_video->packet.data, m_video->packet.size);

        if(m_video->frameFinished)
		{
		//return 0 (viewed all file)
		
		//****************** TEMPORAL *********************//
		SDL_Surface* tmp;
		tmp = SDL_CreateRGBSurface(SDL_HWSURFACE, m_video->pCodecCtx->width, m_video->pCodecCtx->height, 24, 0, 0, 0, 0);
 		
		SDL_Overlay* bmp = SDL_CreateYUVOverlay(m_video->pCodecCtx->width,
				 m_video->pCodecCtx->height,
				 SDL_YV12_OVERLAY,
				 tmp);

		SDL_LockYUVOverlay(bmp);

			AVPicture pict;
			pict.data[0] = bmp->pixels[0];
			pict.data[1] = bmp->pixels[2];
			pict.data[2] = bmp->pixels[1];

			pict.linesize[0] = bmp->pitches[0];
			pict.linesize[1] = bmp->pitches[2];
			pict.linesize[2] = bmp->pitches[1];

			// Convert the image into YUV format that SDL uses
			img_convert(&pict, PIX_FMT_YUV420P,
				            (AVPicture *)m_video->pFrame,m_video->pCodecCtx->pix_fmt, 
					m_video->pCodecCtx->width, m_video->pCodecCtx->height);
	
		SDL_UnlockYUVOverlay(bmp);

		//************************* TEMPORAL ***************** //

        glBindTexture(GL_TEXTURE_2D, m_textureID);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 
        glTexImage2D(GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGB, m_video->pCodecCtx->width, m_video->pCodecCtx->height, 0,
          GL_RGB, GL_UNSIGNED_BYTE, bmp->pixels);

        
       //return 1;
		}
    }
    //return 0;
}

// ============================= RENDER ========================== //
void iVideo::render()
{
		float ratio;
		ratio = (float)352 / (float)240;
		
		//TEXTURE
		glEnable(GL_TEXTURE_RECTANGLE_ARB);
		glBindTexture( GL_TEXTURE_RECTANGLE_ARB, m_textureID );
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		//QUAD
		glBegin(GL_QUADS);
				glTexCoord2f(0.0f, 0.0f); 		glVertex2f( -1*ratio, 1);	
				glTexCoord2f(500, 0.0f); 		glVertex2f( 1*ratio, 1);
				glTexCoord2f(500, 500); 		glVertex2f( 1*ratio, -1);
				glTexCoord2f(0.0f, 500);		glVertex2f( -1*ratio, -1);
		glEnd();
		glDisable(GL_TEXTURE_RECTANGLE_ARB);
		
}

// ============================= GET SIZE ======================== //
void iVideo::get_size(int *w, int *h)
{		

		//*w = m_video->pCodecCtx->width;	// In the case doesn't mach any if
		//*h = m_video->pCodecCtx->height;

		*w = 352;
		*h = 240;
	
		// MAX SIZE
		if(*w > MAX_W)
		{
			float value = MAX_W/float(*w);
			*w = *w * value;
			*h = *h * value;
		}
		if(*h > MAX_H)
		{
			float value = MAX_H/float(*h);					
			*w = *w * value;
			*h = *h * value;			
		}
		// MIN SIZE
		// IF THE SIZE IS SMALLEST THAN 300x300 it runs very slow!!
		if(*w < MIN_W)
		{
			float value = MIN_W/float(*w);						
			*w = *w * value;
			*h = *h * value;			
		}

		if(*h < MIN_H)
		{
			float value = MIN_H/float(*h);				
			*w = *w * value;
			*h = *h * value;			
		}

}

// ============================= LOAD TEXTURE ======================== //
/*void iVideo::load_texture()
{
	// DO This after GL_SETUP -> In main
	GLuint texture;
	glGenTextures(1, &texture);
	glBindTexture(GL_TEXTURE_RECTANGLE_ARB, texture);
	glTexImage2D( GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGB, m_photo->w, m_photo->h, 0,
				       GL_RGB, GL_UNSIGNED_BYTE, m_photo->pixels );
				
	m_textureID = texture;
}*/



// ============================== CREATE VIDEO ================================ //
/*void iVideo::create_video()
{
  AVFormatContext *pFormatCtx;
  int             i, videoStream;
  AVCodecContext  *pCodecCtx;
  AVCodec         *pCodec;
  AVFrame         *pFrame; 
  AVPacket        packet;
  int             frameFinished;
  float           aspect_ratio;

  // Register all formats and codecs
  av_register_all();
  
 
  // Open video file
  if(av_open_input_file(&pFormatCtx, m_filename.c_str(), NULL, 0, NULL)!=0)
    exit(-1); // Couldn't open file
  
  // Retrieve stream information
  if(av_find_stream_info(pFormatCtx)<0)
    exit(-1); // Couldn't find stream information
  
  // Dump information about file onto standard error
  //dump_format(pFormatCtx, 0, m_filename.c_str(), 0);
  
  // Find the first video stream
  videoStream=-1;
  for(i=0; i<pFormatCtx->nb_streams; i++)
    if(pFormatCtx->streams[i]->codec->codec_type==CODEC_TYPE_VIDEO) {
      videoStream=i;
      break;
    }
  if(videoStream==-1)
    exit(-1); // Didn't find a video stream
  
  // Get a pointer to the codec context for the video stream
  pCodecCtx=pFormatCtx->streams[videoStream]->codec;
  
  // Find the decoder for the video stream
  pCodec=avcodec_find_decoder(pCodecCtx->codec_id);
  if(pCodec==NULL) {
    fprintf(stderr, "Unsupported codec!\n");
    exit(-1); // Codec not found
  }
  
  // Open codec
  if(avcodec_open(pCodecCtx, pCodec)<0)
    exit(-1); // Could not open codec
  
  // Allocate video frame
  pFrame=avcodec_alloc_frame();


}*/

void iVideo::create_video() {
	
	int i;

	av_register_all();

	 if(av_open_input_file(&m_video->pFormatCtx, m_filename.c_str(), NULL, 0, NULL)!=0)
		exit(-1); // Couldn't open file
	  
	  // Retrieve stream information
	  if(av_find_stream_info(m_video->pFormatCtx)<0)
		exit(-1); // Couldn't find stream information
	  
	  // Dump information about file onto standard error
	 // dump_format(m_video->pFormatCtx, 0, m_filename.c_str(), 0);
	  
	  // Find the first video stream
	  m_video->videoStream=-1;
	  for(i=0; i<m_video->pFormatCtx->nb_streams; i++)
		if(m_video->pFormatCtx->streams[i]->codec->codec_type==CODEC_TYPE_VIDEO) {
		  m_video->videoStream=i;
		  break;
		}

	  if(m_video->videoStream==-1)
		exit(-1); // Didn't find a video stream
 
	  // Get a pointer to the codec context for the video stream 
	  m_video->pCodecCtx = m_video->pFormatCtx->streams[m_video->videoStream]->codec;

	
	  // Find the decoder for the video stream
	  m_video->pCodec=avcodec_find_decoder(m_video->pCodecCtx->codec_id);
	  if(m_video->pCodec==NULL) {
		fprintf(stderr, "Unsupported codec!\n");
		exit(-1); // Codec not found
	  }
	  printf("Video Decoder Finded\n");
	  // Open codec
	  if(avcodec_open(m_video->pCodecCtx, m_video->pCodec)<0)
		exit(-1); // Could not open codec
	  
	  // Allocate video frame
	  m_video->pFrame=avcodec_alloc_frame();

	printf("Video Loaded sucesfully (SIZE:%dx%d)\n",m_video->pCodecCtx->width,m_video->pCodecCtx->height);
 
}
// =========================== DESTROY VIDEO =========================== //
void iVideo::destroy_video(Video* video) 
{
    //glDeleteTextures(1, &video->texture);   
    delete video;
}
