//g++ -fPIC -c iPhoto.cpp
//g++ -shared -Wl,-soname,iPhoto.so -o iPhoto.so iPhoto.o -lSDL -lSDL_image


#ifndef _IVIDEO_
#define _IVIDEO_

#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>
#include <ffmpeg/swscale.h>

#include <SDL/SDL.h>
#include "../iGloobus.h"


#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iVideo"	// TODO: Define here the plugin Name

using namespace std;

struct Video{
 
  AVFormatContext *pFormatCtx;
  int 			  videoStream;
  AVCodecContext  *pCodecCtx;
  AVCodec         *pCodec;
  AVFrame         *pFrame; 
  AVPacket        packet;
  int             frameFinished;
  float           aspect_ratio;
  AVFrame		  *frame_rgb;

};


// ============================ Plugin Class iPhoto ==================================== //

class iVideo : public iGloobus 	//Class inherited from iGloobus
{	
	private:
	Video										*m_video;
	
	public:
	virtual void load();						// Load the Photo
	virtual void init();						// Initialize the plugin
	virtual void end();							// Destroy the plugin
	virtual void render();						// Render function	
	virtual void update(char key[]);			// Update function
	virtual void get_size(int *w, int *h);		// To know the size of the GL window (on preview)
		
	//void			load_texture();					 // Private (Load Texture)	
	void 			create_video();
	void			destroy_video(Video* video) ;
};



// ============================ Class factories======================================== //

extern "C" iGloobus* create() {		
	printf("Creating iVideo...\n");
    return new iVideo;
}

extern "C" void destroy(iGloobus* p) {
	printf("Destroying iVideo...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "video/mpeg",1};		// Initial filetype

			factory[itself.name] = create;		    // Register the plugin
			factoryDestroy[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);			// Add filetype that plugin reads
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

